#include <iostream>
#include <string>
#include <Magick++.h>

#include <sys/types.h>
#include <unistd.h>

using namespace std;
using namespace Magick; 

unsigned int seed32_1, seed32_2;
unsigned int xrng64() {
	static unsigned int d = 123;
	unsigned int t = seed32_1 ^ (seed32_1 << 10);
	seed32_1 = seed32_2;
	seed32_2 = (seed32_2^(seed32_2>>10))^(t^(t>>13));
	return seed32_1 + (d+=362437);
}
                                                                                                                                                                
int main(int argc, char** argv) {
  seed32_1 = time(NULL);
  seed32_2 = getpid();
  for (unsigned i = 0; i < 1024; ++i)
	xrng64();
  if (argc <= 1) {
    cout << "Please specify a image file!" << endl;
    return 1;
  }
  string infile = argv[1];
  string::size_type pos = infile.find_last_of('.');
  if (pos == string::npos) {
    cout << "Unknown extension ?!?" << endl;
    return 1;
  }
  string outfile1 = infile.substr(0,pos) + "_1" + infile.substr(pos);
  string outfile2 = infile.substr(0,pos) + "_2" + infile.substr(pos);
  string outfile3 = infile.substr(0,pos) + "_1+2" + infile.substr(pos);
  Image image;
  try {
    image.read(infile);
    image.type(BilevelType);
    if ((image.columns() >= image.rows() && image.columns() > 500)
       || (image.rows() > image.columns() && image.rows() > 500))
      image.zoom("500 x 500");
    Image image1(Geometry(image.columns()*2,image.rows()*2),ColorMono());
    Image image2 = image1, image3 = image1;
    for (unsigned c = 0; c < image.columns(); ++c)
      for (unsigned r = 0; r < image.rows(); ++r)
      {
        unsigned k = xrng64() % 6;
        bool col1 = true, col2= false, col3 =false, col4=false;
        switch (k%3) {
        case 0: col2 = true; break;
        case 1: col3 = true; break;
        case 2: col4 = true; break;
        }
        if (k < 3) {
          col1 = !col1; col2 = !col2;
          col3 = !col3; col4 = !col4;
        }
        bool col1b = col1, col2b = col2, col3b = col3, col4b = col4;
        if (ColorMono(image.pixelColor(c,r)).mono()) {
          col1b = !col1b; col2b = !col2b;
          col3b = !col3b; col4b = !col4b;
        }
        image1.pixelColor(2*c+0,2*r+0,ColorMono(col1));
        image1.pixelColor(2*c+0,2*r+1,ColorMono(col2));
        image1.pixelColor(2*c+1,2*r+0,ColorMono(col3));
        image1.pixelColor(2*c+1,2*r+1,ColorMono(col4));
        image2.pixelColor(2*c+0,2*r+0,ColorMono(col1b));
        image2.pixelColor(2*c+0,2*r+1,ColorMono(col2b));
        image2.pixelColor(2*c+1,2*r+0,ColorMono(col3b));
        image2.pixelColor(2*c+1,2*r+1,ColorMono(col4b));
        image3.pixelColor(2*c+0,2*r+0,ColorMono(col1&col1b));
        image3.pixelColor(2*c+0,2*r+1,ColorMono(col2&col2b));
        image3.pixelColor(2*c+1,2*r+0,ColorMono(col3&col3b));
        image3.pixelColor(2*c+1,2*r+1,ColorMono(col4&col4b));
      }
    cout << "<a href='" << outfile1 << "'>Output file 1</a><br/>" << endl;
    cout << "<img src='" << outfile1 << "' border=1/><br/>" << endl;
    cout << "<a href='" << outfile2 << "'>Output file 2</a><br/>" << endl;
    cout << "<img src='" << outfile2 << "' border=1/><br/>" << endl;
    cout << "<a href='" << outfile3 << "'>Output file 1+2</a><br/>" << endl;
    cout << "<img src='" << outfile3 << "' border=1/><br/>" << endl;
    cout << "<br/>" << endl;
    image1.write(outfile1);
    image2.write(outfile2);
    image3.write(outfile3);
  } catch (Exception& e) {
    cout << "Caught exception: " << e.what() << endl;
    return 1;
  }
  return 0;
}
